<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\HistoryRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;
use App\Read;
use App\User;
use App\Device;
use App\History;

class HistoryController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/histories';
    /** View folder */
    private $viewDirectory= 'admin.histories.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('histories.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the histories.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $ids = History::pluck('user_id');
        $query = User::whereIn('id',$ids)->orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $histories= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('histories'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('histories.store');
        $head = metaFields('histories', 'add_new', getCurrentLocale()) ?? __('histories.new');

        $users = User::where('role_id','6')->get();
        return view( $this->viewDirectory.'form', compact('action', 'head','users') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param HistoryRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(HistoryRequest $request) :RedirectResponse
    {
     
        
        $this->saveData( $request, $request->user_id );

        
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  History  $history
     * @return View
     */
    public function edit(User $history): View
    {
        $action= route('histories.update', $history->id);
        $head = metaFields('histories', 'edit', getCurrentLocale()) ?? __('histories.edit');
        $users = User::where('role_id','6')->get();
        $reads =Read::where('history_id',$history->id)->get();
        $devices = Device::cursor();
        $histories = History::where('user_id',$history->id)->get();
        
        
        return view( $this->viewDirectory.'form', compact('history','histories', 'action', 'head','users','reads','devices') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  HistoryRequest  $request
     * @param  History  $history
     * @return RedirectResponse|Redirector
     */
    public function update(HistoryRequest $request, $id) :RedirectResponse
    {
      //dd($request->all());
        $ids = History::where('user_id',$request->user_id)->pluck('id');
        
         Read::whereIn('history_id', $ids)->forceDelete();
         History::where('user_id',$request->user_id)->forceDelete();

        // Insert new description
        $this->saveData( $request, $request->user_id );
		
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
    
    
    private function saveData(Request $request, int $id ):void
    {
        
       if (!is_null($request->history))
       {
           
            foreach ($request->history as $row)
            {
                $history = History::create([
            'user_id'=>$id,
            'date'=>$row['date'],
            'weight'=>$row['weight'],
            'fat'=>$row['fat'],
            'muscle'=>$row['muscle'],
            'liquid'=>$row['liquid'],
            'bone'=>$row['bone'],
            'trust'=>$row['trust'],
            'sport'=>$row['sport'],
            'recommend'=>$row['recommend'],
            'complain'=>$row['complain'],
            'system'=>$row['system'],
            'note'=>$row['note'],
                                            ]);
            if(is_null($history->date)){
                $history->update(['date'=>date('Y-m-d')]);
            }
            
                if (isset($row['read']))
                {

                    foreach ($row['read'] as $read) 
                    {
                Read::create([
            'history_id'=>$history->id,
            'device_id'=>$read['device_id'],
            'number'=>$read['number']
                              ]);

                    }
                }
            }
        }

    }
    

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = History::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            History::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            History::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = History::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = History::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
